# Название:    Центра компонента
# Сайт:           stroyka.cc 
# Дата:           2.09.2009         
# Автор:         Sahi (г.Рязань)
# Описание:  Данный скрипт меняет центр у компонента

# ********************************************************************************#

#     Прочтите внимательно следующее лицензионное соглашение.

# 1. Скрипт «Центр компонента» является частной авторской интеллектуальной собственностью.

# 2. Всеми  авторскими правами на данный скрипт эксклюзивно владеет его
# автор-sahi, в дальнейшем именуемым автором. Сайт автора и его
# студии являются единственными авторами ДАННОГО ФАЙЛА.

# 3. Данный скрипт распространяется по принципу «как есть» (AS IS). При
# этом не предусматривается не каких гарантий, явных или подразумеваемых.
# Весь риск за возможные последствия применения этой программы лежит
# исключительно на пользователе. Автор не несет никакой ответственности за
# потери данных, повреждения, упущенную прибыль и любые другие возможные
# осложнения, связанные с использованием (правильным или неправильным)
# данного пакета локализации. Но все же, все пакеты локализации тестируются на
# работоспособность автором перевода.

# 4.Запрещается присваивания авторства данного скрипта после внесения изменений/
# доработок. Если по каким-либо причинам Вам потребуется доработать
# скрипт «Центр компонента», это допускается делать лишь с сохранением авторских прав за
# sahi и по предварительному согласованию автора.

# 5. Запрещается изменения архива скрипта и любых его компанентов, в т.ч.
# файла лицензии ,файла перевода, Readme файла, переведенного файла.
# Добавление каких-либо файлов в архив также считается изменением.

# 6. Запрещается публикация скрипта на других сайтах (физическое
# размещение скрипта «Кирпичи» на сервере) Указание ссылки на сам скрипт
# «Кирпичи» не является нарушением данного условия.

# 7. . Запрещается публикация скрипта «Центр компонента»  на CD или любых других
# Носителях информации. Выполнение данного условия  поощряется.

# Установка и использование скрипта «Центр компонента»   свидетельствует
# о Вашем согласии с условием данной лицензии.

# Если Вы не согласны с вышеперечисленными условиями, то должны
# отказаться от использования  скрипта «Кирпичи» и удалить все его
# компоненты со своих  носителей информации.

# Авторские права - sahi®
# www.stroyka.сс

#=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=#                                             
    require 'sketchup.rb'
                                                       
def centrcomponents1
                              
      ss=Sketchup.active_model.selection  ###
                             
      if ss.empty? 
           UI.messagebox("No Selection.")
         return nil
       end 
                                      
        ss.each{|comp|
          if(comp.class==Sketchup::ComponentInstance)
                point0 = comp.bounds.center.clone
                definitions = comp.definition
                num = definitions.count_instances 
                ents1 = definitions.instances
                ents2 = Sketchup.active_model.active_entities.add_group(ents1)
                point = definitions.insertion_point
                ents = definitions.entities
                new_center = definitions.bounds.center.clone
                qvec = new_center.vector_to point
                t = Geom::Transformation.translation qvec
                    sents = [];ents.each {|e| sents.push(e) };ents.transform_entities(t, sents)
                    point2 = ents2.bounds.center.clone
                    cvec = point2.vector_to point0
                    tt = Geom::Transformation.translation cvec
                   ents2.transform!(tt);ents2.explode
                    if(num > 1)
                      return nil
                    end 
               end
            }
            
          Sketchup.active_model.selection.clear
        
      end                                                       
def centrcomponents2
                              
      ss=Sketchup.active_model.selection  ###
                             
      if ss.empty? 
           UI.messagebox("No Selection.")
         return nil
       end 
                                      
        ss.each{|comp|
          if(comp.class==Sketchup::ComponentInstance)
                point0 = comp.bounds.center.clone
                definitions = comp.definition
                num = definitions.count_instances 
                ents1 = definitions.instances
                ents2 = Sketchup.active_model.active_entities.add_group(ents1)
                point = definitions.insertion_point
                ents = definitions.entities
                pts1 = definitions.bounds.corner(0).clone
                pts2 = definitions.bounds.corner(3).clone
                distan = pts1.distance pts2
                vec_diag = pts2 - pts1
                point2 = pts1.offset(vec_diag, distan/2)
                qvec = point2.vector_to point
                t = Geom::Transformation.translation qvec
                    sents = [];ents.each {|e| sents.push(e) };ents.transform_entities(t, sents)
                    point2 = ents2.bounds.center.clone
                    cvec = point2.vector_to point0
                    tt = Geom::Transformation.translation cvec
                    ents2.transform!(tt);ents2.explode
                   if(num > 1)
                      return nil
                    end   
               end
            }
            
          Sketchup.active_model.selection.clear
        
      end
                               
  def centrcomponents3
                              
      ss=Sketchup.active_model.selection  ###
                             
      if ss.empty? 
           UI.messagebox("No Selection.")
         return nil
       end 
                                      
        ss.each{|comp|
          if(comp.class==Sketchup::ComponentInstance)
                point0 = comp.bounds.center.clone
                definitions = comp.definition
                num = definitions.count_instances 
                ents1 = definitions.instances
                ents2 = Sketchup.active_model.active_entities.add_group(ents1)
                point = definitions.insertion_point
                ents = definitions.entities
                pts1 = definitions.bounds.corner(4).clone
                pts2 = definitions.bounds.corner(7).clone
                distan = pts1.distance pts2
                vec_diag = pts2 - pts1
                point2 = pts1.offset(vec_diag, distan/2)
                qvec = point2.vector_to point
                t = Geom::Transformation.translation qvec
                    sents = [];ents.each {|e| sents.push(e) };ents.transform_entities(t, sents)
                    point2 = ents2.bounds.center.clone
                    cvec = point2.vector_to point0
                    tt = Geom::Transformation.translation cvec
                    ents2.transform!(tt);ents2.explode
                   if(num > 1)
                      return nil
                    end   
               end
            }
            
          Sketchup.active_model.selection.clear
        
      end
      
        def centrcomponentsleft1
                              
      ss=Sketchup.active_model.selection  ###
                             
      if ss.empty? 
           UI.messagebox("No Selection.")
         return nil
       end 
                                      
        ss.each{|comp|
          if(comp.class==Sketchup::ComponentInstance)
                 point0 = comp.bounds.corner(0)
                 definitions = comp.definition
                 num = definitions.count_instances 
                 ents1 = definitions.instances
                 ents2 = Sketchup.active_model.active_entities.add_group(ents1)
                  point = definitions.insertion_point
                  ents = definitions.entities
                  new_center = definitions.bounds.corner(0)
                  qvec = new_center.vector_to point
                   t = Geom::Transformation.translation qvec
                   sents = []; ents.each {|e| sents.push(e) };ents.transform_entities(t, sents)
                   point5 = ents2.bounds.corner(0)
                   cvec = point5.vector_to point0
                   tt = Geom::Transformation.translation cvec
                   ents2.transform!(tt);ents2.explode
                     if(num > 1)
                      return nil
                      end 
                end
            }
            
          Sketchup.active_model.selection.clear
        
      end
      
    def centrcomponentsleft2
                              
      ss=Sketchup.active_model.selection  ###
                             
      if ss.empty? 
           UI.messagebox("No Selection.")
         return nil
       end 
                                      
        ss.each{|comp|
          if(comp.class==Sketchup::ComponentInstance)
                  
                 point0 = comp.bounds.corner(1)
                 definitions = comp.definition
                 num = definitions.count_instances 
                 ents1 = definitions.instances
                 ents2 = Sketchup.active_model.active_entities.add_group(ents1)
                  point = definitions.insertion_point
                  ents = definitions.entities
                  new_center = definitions.bounds.corner(1)
                  qvec = new_center.vector_to point
                   t = Geom::Transformation.translation qvec
                   sents = []; ents.each {|e| sents.push(e) };ents.transform_entities(t, sents)
                   point5 = ents2.bounds.corner(1)
                   cvec = point5.vector_to point0
                   tt = Geom::Transformation.translation cvec
                   ents2.transform!(tt);ents2.explode
                     if(num > 1)
                      return nil
                      end 
                end
            }
            
          Sketchup.active_model.selection.clear
        
      end
                                                      
      def centrcomponentsright1
                              
      ss=Sketchup.active_model.selection  ###
                             
      if ss.empty? 
           UI.messagebox("No Selection.")
         return nil
       end 
                                      
        ss.each{|comp|
          if(comp.class==Sketchup::ComponentInstance)
                 point0 = comp.bounds.corner(2)
                 definitions = comp.definition
                 num = definitions.count_instances 
                 ents1 = definitions.instances
                 ents2 = Sketchup.active_model.active_entities.add_group(ents1)
                  point = definitions.insertion_point
                  ents = definitions.entities
                  new_center = definitions.bounds.corner(2)
                  qvec = new_center.vector_to point
                   t = Geom::Transformation.translation qvec
                   sents = []; ents.each {|e| sents.push(e) };ents.transform_entities(t, sents)
                   point5 = ents2.bounds.corner(2)
                   cvec = point5.vector_to point0
                   tt = Geom::Transformation.translation cvec
                   ents2.transform!(tt);ents2.explode
                     if(num > 1)
                      return nil
                      end 
                end
            }
            
          Sketchup.active_model.selection.clear
        
      end
       def centrcomponentsright2
                              
      ss=Sketchup.active_model.selection  ###
                             
      if ss.empty? 
           UI.messagebox("No Selection.")
         return nil
       end 
                            
        model=Sketchup.active_model
        entities=model.active_entities
                                      
        ss.each{|comp|
          if(comp.class==Sketchup::ComponentInstance)
                 point0 = comp.bounds.corner(3)
                 definitions = comp.definition
                 num = definitions.count_instances 
                 ents1 = definitions.instances
                 ents2 = Sketchup.active_model.active_entities.add_group(ents1)
                  point = definitions.insertion_point
                  ents = definitions.entities
                  new_center = definitions.bounds.corner(3)
                  qvec = new_center.vector_to point
                   t = Geom::Transformation.translation qvec
                   sents = []; ents.each {|e| sents.push(e) };ents.transform_entities(t, sents)
                   point5 = ents2.bounds.corner(3)
                   cvec = point5.vector_to point0
                   tt = Geom::Transformation.translation cvec
                   ents2.transform!(tt);ents2.explode
                     if(num > 1)
                      return nil
                      end 
                end
            }
            
          Sketchup.active_model.selection.clear
        
      end
      
         def centrcomponentsleftstorona
                              
      ss=Sketchup.active_model.selection  ###
                             
      if ss.empty? 
           UI.messagebox("No Selection.")
         return nil
       end 
                            
        model=Sketchup.active_model
        entities=model.active_entities
                                      
        ss.each{|comp|
          if(comp.class==Sketchup::ComponentInstance)
                    point2 = comp.bounds.corner(1);point3 = comp.bounds.corner(0)
                    line1 = entities.add_cline(point2, point3)
                     new_center1 = line1.bounds.center;line1.erase!
                    definitions = comp.definition
                    num = definitions.count_instances 
                    ents1 = definitions.instances
                    ents2 = Sketchup.active_model.active_entities.add_group(ents1)
                     point = definitions.insertion_point
                     ents = definitions.entities
                     new_center = definitions.bounds.corner(1)
                     point0 = definitions.bounds.corner(0)
                     line = entities.add_cline(point0, new_center)
                     new_center0 = line.bounds.center
                     line.erase!
                     qvec = new_center0.vector_to point
                     t = Geom::Transformation.translation qvec
                     sents = [];ents.each {|e| sents.push(e) };ents.transform_entities(t, sents)
                     point4 = ents2.bounds.corner(1);point5 = ents2.bounds.corner(0)
                     line2 = entities.add_cline(point4, point5)
                     new_center2 = line2.bounds.center;line2.erase!
                     cvec = new_center2.vector_to new_center1
                     tt = Geom::Transformation.translation cvec
                     ents2.transform!(tt)
                     ents2.explode
                     if(num > 1)
                      return nil
                      end 
               end
            }
            
          Sketchup.active_model.selection.clear
        
      end
      
         def centrcomponentsperedstorona
                              
      ss=Sketchup.active_model.selection  ###
                             
      if ss.empty? 
           UI.messagebox("No Selection.")
         return nil
       end 
                            
        model=Sketchup.active_model
        entities=model.active_entities
                                      
        ss.each{|comp|
          if(comp.class==Sketchup::ComponentInstance)
                    point2 = comp.bounds.corner(1);point3 = comp.bounds.corner(3)
                    line1 = entities.add_cline(point2, point3)
                     new_center1 = line1.bounds.center;line1.erase!
                    definitions = comp.definition
                    num = definitions.count_instances 
                    ents1 = definitions.instances
                    ents2 = Sketchup.active_model.active_entities.add_group(ents1)
                     point = definitions.insertion_point
                     ents = definitions.entities
                     new_center = definitions.bounds.corner(1)
                     point0 = definitions.bounds.corner(3)
                     line = entities.add_cline(point0, new_center)
                     new_center0 = line.bounds.center
                     line.erase!
                     qvec = new_center0.vector_to point
                     t = Geom::Transformation.translation qvec
                     sents = [];ents.each {|e| sents.push(e) };ents.transform_entities(t, sents)
                     point4 = ents2.bounds.corner(1);point5 = ents2.bounds.corner(3)
                     line2 = entities.add_cline(point4, point5)
                     new_center2 = line2.bounds.center;line2.erase!
                     cvec = new_center2.vector_to new_center1
                     tt = Geom::Transformation.translation cvec
                     ents2.transform!(tt)
                     ents2.explode
                     if(num > 1)
                      return nil
                      end 
               end
            }
            
          Sketchup.active_model.selection.clear
        
      end
       
  def centrcomponentsrightstorona
                              
      ss=Sketchup.active_model.selection  ###
                             
      if ss.empty? 
           UI.messagebox("No Selection.")
         return nil
       end 
                            
        model=Sketchup.active_model
        entities=model.active_entities
                                      
        ss.each{|comp|
          if(comp.class==Sketchup::ComponentInstance)
                    point2 = comp.bounds.corner(3);point3 = comp.bounds.corner(2)
                    line1 = entities.add_cline(point2, point3)
                     new_center1 = line1.bounds.center;line1.erase!
                    definitions = comp.definition
                    num = definitions.count_instances 
                    ents1 = definitions.instances
                    ents2 = Sketchup.active_model.active_entities.add_group(ents1)
                     point = definitions.insertion_point
                     ents = definitions.entities
                     new_center = definitions.bounds.corner(3)
                     point0 = definitions.bounds.corner(2)
                     line = entities.add_cline(point0, new_center)
                     new_center0 = line.bounds.center
                     line.erase!
                     qvec = new_center0.vector_to point
                     t = Geom::Transformation.translation qvec
                     sents = [];ents.each {|e| sents.push(e) };ents.transform_entities(t, sents)
                     point4 = ents2.bounds.corner(3);point5 = ents2.bounds.corner(2)
                     line2 = entities.add_cline(point4, point5)
                     new_center2 = line2.bounds.center;line2.erase!
                     cvec = new_center2.vector_to new_center1
                     tt = Geom::Transformation.translation cvec
                     ents2.transform!(tt)
                     ents2.explode
                     if(num > 1)
                      return nil
                      end 
               end
            }
            
          Sketchup.active_model.selection.clear
        
      end
      
  def centrcomponentszadstorona
                              
      ss=Sketchup.active_model.selection  ###
                             
      if ss.empty? 
           UI.messagebox("No Selection.")
         return nil
       end 
                            
        model=Sketchup.active_model
        entities=model.active_entities
                                      
        ss.each{|comp|
          if(comp.class==Sketchup::ComponentInstance)
                    point2 = comp.bounds.corner(2);point3 = comp.bounds.corner(0)
                    line1 = entities.add_cline(point2, point3)
                     new_center1 = line1.bounds.center;line1.erase!
                    definitions = comp.definition
                    num = definitions.count_instances 
                    ents1 = definitions.instances
                    ents2 = Sketchup.active_model.active_entities.add_group(ents1)
                     point = definitions.insertion_point
                     ents = definitions.entities
                     new_center = definitions.bounds.corner(2)
                     point0 = definitions.bounds.corner(0)
                     line = entities.add_cline(point0, new_center)
                     new_center0 = line.bounds.center
                     line.erase!
                     qvec = new_center0.vector_to point
                     t = Geom::Transformation.translation qvec
                     sents = [];ents.each {|e| sents.push(e) };ents.transform_entities(t, sents)
                     point4 = ents2.bounds.corner(2);point5 = ents2.bounds.corner(0)
                     line2 = entities.add_cline(point4, point5)
                     new_center2 = line2.bounds.center;line2.erase!
                     cvec = new_center2.vector_to new_center1
                     tt = Geom::Transformation.translation cvec
                     ents2.transform!(tt)
                     ents2.explode
                     if(num > 1)
                      return nil
                      end 
               end
            }
            
          Sketchup.active_model.selection.clear
        
      end
                                  
  if( not file_loaded?("axiscomp.rb"))###
    
        toolbar_1 = UI::Toolbar.new "Center of component "  
         cmd1 = UI::Command.new("Center of component " ) { centrcomponents2 } 
         cmd1.small_icon = "458.png" 
         cmd1.large_icon = "458.png"  
         cmd1.tooltip = "Center of component " 
         toolbar_1.add_item(cmd1) 
         toolbar_1.show 
   
    submenu = UI.menu("Plugins").add_submenu("Center of component>>> ") 
    submenu.add_item("Center of component ") { centrcomponents1 }
    submenu.add_item("Bottom of center of component  ") { centrcomponents2 }
    submenu.add_item("Top of center of component   ") { centrcomponents3 }
    submenu.add_item("Left distant corner  ") { centrcomponentsleft1 }
    submenu.add_item("Left near corner  ") { centrcomponentsleft2 }
    submenu.add_item("Right distant corner  ") { centrcomponentsright1 }
    submenu.add_item("Right near corner  ") { centrcomponentsright2 }
    submenu.add_item("Center on the left   ") { centrcomponentsleftstorona }
    submenu.add_item("Center at the front   ") { centrcomponentsperedstorona }
    submenu.add_item("Center  from a right   ") { centrcomponentsrightstorona }
    submenu.add_item("Center behind    ") { centrcomponentszadstorona }
end

###
file_loaded("axiscomp.rb")###
###-----------------------------------------------------------------------------
